<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.17"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Moxit: backend/src/lib/game/game.hpp File Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Moxit
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.17 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_8c739bbef76d64b22d6b0911c526dd76.html">backend</a></li><li class="navelem"><a class="el" href="dir_27747142951285b09bacafa002e92b5f.html">src</a></li><li class="navelem"><a class="el" href="dir_cecc8ab0f6e720ec77fada3731d67481.html">lib</a></li><li class="navelem"><a class="el" href="dir_b0ef9bf4b1088606ddc71a6c73915b53.html">game</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#nested-classes">Classes</a> &#124;
<a href="#define-members">Macros</a> &#124;
<a href="#enum-members">Enumerations</a> &#124;
<a href="#func-members">Functions</a>  </div>
  <div class="headertitle">
<div class="title">game.hpp File Reference</div>  </div>
</div><!--header-->
<div class="contents">
<div class="textblock"><code>#include &quot;<a class="el" href="player_8hpp_source.html">player.hpp</a>&quot;</code><br />
<code>#include &quot;<a class="el" href="ChatBackend_8hpp_source.html">../chat/ChatBackend.hpp</a>&quot;</code><br />
<code>#include &lt;string&gt;</code><br />
<code>#include &lt;cassert&gt;</code><br />
<code>#include &lt;vector&gt;</code><br />
<code>#include &lt;iostream&gt;</code><br />
<code>#include &lt;ctime&gt;</code><br />
<code>#include &lt;random&gt;</code><br />
<code>#include &lt;algorithm&gt;</code><br />
<code>#include &lt;unordered_map&gt;</code><br />
<code>#include &lt;stdlib.h&gt;</code><br />
<code>#include &lt;QJsonDocument&gt;</code><br />
<code>#include &lt;QByteArray&gt;</code><br />
<code>#include &lt;QString&gt;</code><br />
<code>#include &lt;QTime&gt;</code><br />
</div><div class="textblock"><div class="dynheader">
Include dependency graph for game.hpp:</div>
<div class="dyncontent">
<div class="center"><img src="game_8hpp__incl.png" border="0" usemap="#backend_2src_2lib_2game_2game_8hpp" alt=""/></div>
<map name="backend_2src_2lib_2game_2game_8hpp" id="backend_2src_2lib_2game_2game_8hpp">
<area shape="rect" title=" " alt="" coords="645,5,805,47"/>
<area shape="rect" href="player_8hpp.html" title=" " alt="" coords="235,95,325,121"/>
<area shape="rect" title=" " alt="" coords="5,169,64,196"/>
<area shape="rect" title=" " alt="" coords="449,169,529,196"/>
<area shape="rect" title=" " alt="" coords="89,169,151,196"/>
<area shape="rect" title=" " alt="" coords="175,169,299,196"/>
<area shape="rect" href="ChatBackend_8hpp.html" title=" " alt="" coords="400,95,579,121"/>
<area shape="rect" title=" " alt="" coords="603,95,672,121"/>
<area shape="rect" title=" " alt="" coords="696,95,755,121"/>
<area shape="rect" title=" " alt="" coords="779,95,851,121"/>
<area shape="rect" title=" " alt="" coords="875,95,960,121"/>
<area shape="rect" title=" " alt="" coords="985,95,1055,121"/>
<area shape="rect" title=" " alt="" coords="1079,95,1206,121"/>
<area shape="rect" title=" " alt="" coords="1230,95,1327,121"/>
<area shape="rect" title=" " alt="" coords="1351,95,1422,121"/>
<area shape="rect" title=" " alt="" coords="1446,95,1511,121"/>
<area shape="rect" title=" " alt="" coords="324,169,425,196"/>
<area shape="rect" title=" " alt="" coords="651,169,746,196"/>
<area shape="rect" title=" " alt="" coords="554,169,627,196"/>
</map>
</div>
</div><div class="textblock"><div class="dynheader">
This graph shows which files directly or indirectly include this file:</div>
<div class="dyncontent">
<div class="center"><img src="game_8hpp__dep__incl.png" border="0" usemap="#backend_2src_2lib_2game_2game_8hppdep" alt=""/></div>
<map name="backend_2src_2lib_2game_2game_8hppdep" id="backend_2src_2lib_2game_2game_8hppdep">
<area shape="rect" title=" " alt="" coords="283,5,443,47"/>
<area shape="rect" href="game_8cpp.html" title=" " alt="" coords="5,95,165,136"/>
<area shape="rect" href="game_2test_8cpp.html" title=" " alt="" coords="189,95,349,136"/>
<area shape="rect" href="moxit__server_8h.html" title=" " alt="" coords="374,95,538,136"/>
<area shape="rect" href="test__game__player_8cpp.html" title=" " alt="" coords="562,95,726,136"/>
<area shape="rect" href="moxit__server_8cpp.html" title=" " alt="" coords="279,184,443,225"/>
<area shape="rect" href="backend_2src_2main_8cpp.html" title=" " alt="" coords="468,191,631,218"/>
</map>
</div>
</div>
<p><a href="game_8hpp_source.html">Go to the source code of this file.</a></p>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="nested-classes"></a>
Classes</h2></td></tr>
<tr class="memitem:"><td class="memItemLeft" align="right" valign="top">class &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classGame.html">Game</a></td></tr>
<tr class="separator:"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="define-members"></a>
Macros</h2></td></tr>
<tr class="memitem:ab0c0a3c6a75b9ecaef750e8568b8154a"><td class="memItemLeft" align="right" valign="top">#define&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="game_8hpp.html#ab0c0a3c6a75b9ecaef750e8568b8154a">MAX_HANDSIZE</a>&#160;&#160;&#160;(6)</td></tr>
<tr class="separator:ab0c0a3c6a75b9ecaef750e8568b8154a"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a1409378747976a5bb615f2fb82bd5f2a"><td class="memItemLeft" align="right" valign="top">#define&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="game_8hpp.html#a1409378747976a5bb615f2fb82bd5f2a">MAXPOINTS</a>&#160;&#160;&#160;(3)</td></tr>
<tr class="separator:a1409378747976a5bb615f2fb82bd5f2a"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a660b952bdfedb21a69ac89abff2ed320"><td class="memItemLeft" align="right" valign="top">#define&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="game_8hpp.html#a660b952bdfedb21a69ac89abff2ed320">DECKSIZE</a>&#160;&#160;&#160;(84)</td></tr>
<tr class="separator:a660b952bdfedb21a69ac89abff2ed320"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:abe7fa109b307717bbb95f3099e018dd7"><td class="memItemLeft" align="right" valign="top">#define&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="game_8hpp.html#abe7fa109b307717bbb95f3099e018dd7">INITIALDEAL</a>&#160;&#160;&#160;(6)</td></tr>
<tr class="separator:abe7fa109b307717bbb95f3099e018dd7"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="enum-members"></a>
Enumerations</h2></td></tr>
<tr class="memitem:a896617de6e1c82953f407789633057d8"><td class="memItemLeft" align="right" valign="top">enum &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="game_8hpp.html#a896617de6e1c82953f407789633057d8">GamePhase</a> { <a class="el" href="game_8hpp.html#a896617de6e1c82953f407789633057d8ac52d0203e4390732df39b52244d67338">GamePhase::NARRATOR_CHOICE</a>, 
<a class="el" href="game_8hpp.html#a896617de6e1c82953f407789633057d8a1fc4773f3e7481f16493dffd96f73ebe">GamePhase::PLAYERS_CHOOSE</a>, 
<a class="el" href="game_8hpp.html#a896617de6e1c82953f407789633057d8a10f9a5845f99f7ae9964649ef885b1de">GamePhase::PLAYERS_VOTE</a>
 }</td></tr>
<tr class="separator:a896617de6e1c82953f407789633057d8"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="func-members"></a>
Functions</h2></td></tr>
<tr class="memitem:a97cf14a397ed31f6f3aae282542c04c0"><td class="memItemLeft" align="right" valign="top">std::string&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="game_8hpp.html#a97cf14a397ed31f6f3aae282542c04c0">gamePhaseToStr</a> (<a class="el" href="game_8hpp.html#a896617de6e1c82953f407789633057d8">GamePhase</a> gamePhase)</td></tr>
<tr class="separator:a97cf14a397ed31f6f3aae282542c04c0"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a831a32b1db23c94285b28418d2e33fb2"><td class="memItemLeft" align="right" valign="top"><a class="el" href="game_8hpp.html#a896617de6e1c82953f407789633057d8">GamePhase</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="game_8hpp.html#a831a32b1db23c94285b28418d2e33fb2">strToGamePhase</a> (std::string strGamePhase)</td></tr>
<tr class="separator:a831a32b1db23c94285b28418d2e33fb2"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a0013c8a33b5b108c8b814c503ff23cd4"><td class="memItemLeft" align="right" valign="top">std::ostream &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="game_8hpp.html#a0013c8a33b5b108c8b814c503ff23cd4">operator&lt;&lt;</a> (std::ostream &amp;out, const <a class="el" href="classGame.html">Game</a> &amp;g)</td></tr>
<tr class="separator:a0013c8a33b5b108c8b814c503ff23cd4"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<h2 class="groupheader">Macro Definition Documentation</h2>
<a id="a660b952bdfedb21a69ac89abff2ed320"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a660b952bdfedb21a69ac89abff2ed320">&#9670;&nbsp;</a></span>DECKSIZE</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">#define DECKSIZE&#160;&#160;&#160;(84)</td>
        </tr>
      </table>
</div><div class="memdoc">

</div>
</div>
<a id="abe7fa109b307717bbb95f3099e018dd7"></a>
<h2 class="memtitle"><span class="permalink"><a href="#abe7fa109b307717bbb95f3099e018dd7">&#9670;&nbsp;</a></span>INITIALDEAL</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">#define INITIALDEAL&#160;&#160;&#160;(6)</td>
        </tr>
      </table>
</div><div class="memdoc">

</div>
</div>
<a id="ab0c0a3c6a75b9ecaef750e8568b8154a"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ab0c0a3c6a75b9ecaef750e8568b8154a">&#9670;&nbsp;</a></span>MAX_HANDSIZE</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">#define MAX_HANDSIZE&#160;&#160;&#160;(6)</td>
        </tr>
      </table>
</div><div class="memdoc">

</div>
</div>
<a id="a1409378747976a5bb615f2fb82bd5f2a"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a1409378747976a5bb615f2fb82bd5f2a">&#9670;&nbsp;</a></span>MAXPOINTS</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">#define MAXPOINTS&#160;&#160;&#160;(3)</td>
        </tr>
      </table>
</div><div class="memdoc">

</div>
</div>
<h2 class="groupheader">Enumeration Type Documentation</h2>
<a id="a896617de6e1c82953f407789633057d8"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a896617de6e1c82953f407789633057d8">&#9670;&nbsp;</a></span>GamePhase</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">enum <a class="el" href="game_8hpp.html#a896617de6e1c82953f407789633057d8">GamePhase</a></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">strong</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<table class="fieldtable">
<tr><th colspan="2">Enumerator</th></tr><tr><td class="fieldname"><a id="a896617de6e1c82953f407789633057d8ac52d0203e4390732df39b52244d67338"></a>NARRATOR_CHOICE&#160;</td><td class="fielddoc"></td></tr>
<tr><td class="fieldname"><a id="a896617de6e1c82953f407789633057d8a1fc4773f3e7481f16493dffd96f73ebe"></a>PLAYERS_CHOOSE&#160;</td><td class="fielddoc"></td></tr>
<tr><td class="fieldname"><a id="a896617de6e1c82953f407789633057d8a10f9a5845f99f7ae9964649ef885b1de"></a>PLAYERS_VOTE&#160;</td><td class="fielddoc"></td></tr>
</table>

</div>
</div>
<h2 class="groupheader">Function Documentation</h2>
<a id="a97cf14a397ed31f6f3aae282542c04c0"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a97cf14a397ed31f6f3aae282542c04c0">&#9670;&nbsp;</a></span>gamePhaseToStr()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">std::string gamePhaseToStr </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="game_8hpp.html#a896617de6e1c82953f407789633057d8">GamePhase</a>&#160;</td>
          <td class="paramname"><em>gamePhase</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

</div>
</div>
<a id="a0013c8a33b5b108c8b814c503ff23cd4"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a0013c8a33b5b108c8b814c503ff23cd4">&#9670;&nbsp;</a></span>operator&lt;&lt;()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">std::ostream&amp; operator&lt;&lt; </td>
          <td>(</td>
          <td class="paramtype">std::ostream &amp;&#160;</td>
          <td class="paramname"><em>out</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="classGame.html">Game</a> &amp;&#160;</td>
          <td class="paramname"><em>g</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

</div>
</div>
<a id="a831a32b1db23c94285b28418d2e33fb2"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a831a32b1db23c94285b28418d2e33fb2">&#9670;&nbsp;</a></span>strToGamePhase()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="game_8hpp.html#a896617de6e1c82953f407789633057d8">GamePhase</a> strToGamePhase </td>
          <td>(</td>
          <td class="paramtype">std::string&#160;</td>
          <td class="paramname"><em>strGamePhase</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

</div>
</div>
</div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.17
</small></address>
</body>
</html>
